//-------------------------------------------------------------------------
/*
Copyright (C) 2000, 2003 - Justin Marshall(WinEDuke)

This file is part of Windows Enhanced Duke Nukem 3D version 1.5 - Atomic Edition

Duke Nukem 3D is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

ORIGINAL: Justin Marshall

NOTE: This file handles all console related items...
*/
//-------------------------------------------------------------------------
#include <time.h>
#include "duke3d.h"

#define MAXCVARS 300 // increase as needed

void cvarmap(void);
void cvargod(void);
void cvarirule(void);
void cvarallweapons(void);
void cvarnoclip(void);
void cvarcrosshair(void);
void cvarcoop(void);

char registeredcvars[MAXCVARS][30]; 
char consolebuffer[50000];
console_buffer con_buffer;
char parms[45];
int maxparms = 0;

/*
	void Con_Print(char *buf)
    char *buf - text to print

	Puts text into a buffer, and updates the line feed,
	this is how scrolling works...
*/

void Con_Print(char *buf)
{
	strcpy(con_buffer.buffer[con_buffer.numlinesused],buf);
	con_buffer.numlinesused++;
	con_buffer.maxdrawline = con_buffer.numlinesused; // move the view point down to here.
}

/*
	void RegisterCvar(char *name,char *value, void *func)

    char *name - cvar name to register MUST BE CAPITAL!
	char *value - inital value of the cvar
	void *func - not used

    All console functions/variables must first be INIT with RegisterCvar, basiclly,
	it handles what line we are on, and adds the appriate data to the array...

    This function is my personal favorite...it was the only function i coded the first time,
	and the damn thing, worked as it should..the first time
*/
void RegisterCvar(char *name,char *value, void *func)
{
	strcpy(cvar.registeredcvars[cvar.curr_cvar],name);
	strcpy(cvar.registeredcvarvalues[cvar.curr_cvar],value);
	cvar.curr_cvar++;
	//cvar.func[cvar.curr_cvar] = func;  -- PART OF OLD CONSOLE SYSTEM
}
/*
	DOES NOT WORK

	void SetCvar(char *name,char *value)

	DOES NOT WORK
*/
void SetCvar(char *name,char *value)
{
	int i;
	char temp[450];

	for(i=0; i<cvar.curr_cvar; i++)
	{
		if(cvar.registeredcvars[i] == name)
		{
			strcpy(cvar.registeredcvarvalues[i],value);
			return;
		}
	}
	sprintf(temp,"Unkown command: %s",buf);
	Con_Print(buf);
}

/*
	void HandleCvar(char *buf, int size)

	buf - input text(from console)
	size - size of text to pharse(ex sizeof(buf))

    Handles the cvar when entered, and finds the valid function to carry out if it is valid...
	if it is not..say so

    TODO: There has to be a better way for this...
*/
void HandleCvar(char *buf, int size)
{
	int i=0,f=0,a=0;
	char temp[450];
	void *func;
	int currcommand;
	bool foundspace = false;
	char *cmd;

	foundspace = false;
//	printf("\nsizeof buffer(%s) is %d\n",buf,size);
	// get the parmeter string
	for(i=0; i<=size; i++)
	{
		if(foundspace == false)
		{
			if(buf[i] == ' ')
			{
				foundspace = true;
			}
			else
			{
				cmd[i] = buf[i];
		//		printf("%d%c:%c\n",i,cmd[i],buf[i]);
			}
		}
		else
		{
		//	printf("DEBUG Getting parmetor list\n");
			for(f=i; f<=size; f++)
			{
				parms[a] = buf[f];		
				a++;
			}
		//	printf("%s parmetor string is %s", cmd,parms);
			goto BYPASS_LOOP;
		}
	}
BYPASS_LOOP:
	// TODO: Add your commands here...
	if(!strcmp("CVARLIST",cmd))
	{
		cvarlist();
		return;
	}
	if(!strcmp("MAP",cmd))
	{
		cvarmap();
		return;
	}
	if(!strcmp("GOD",cmd))
	{
		cvargod();
		return;
	}
	if(!strcmp("IRULE",cmd))
	{
		cvarirule();
		return;
	}
	if(!strcmp("ALLWEAPONS",cmd))
	{
		cvarallweapons();
		return;
	}
	if(!strcmp("NOCLIP",cmd))
	{
		cvarnoclip();
		return;
	}
	if(!strcmp("CROSSHAIR",cmd))
	{
		cvarcrosshair();
		return;
	}
	if(!strcmp("COOP",cmd))
	{
		cvarcoop();
		return;
	}
	// last check -- could it be a variable?
	for(i=0;i<cvar.curr_cvar; i++)
	{
		if(!strcmp(cvar.registeredcvars[i],cmd))
			goto FOUND_CMD;
	}
	sprintf(temp,"Unkown command: %s",cmd);
	Con_Print(temp);
FOUND_CMD:
	return;
}


//////////////////////////////////////////////////////////////////////////////////////////////
// ALL cvar functions go under here
//////////////////////////////////////////////////////////////////////////////////////////////

void cvarcoop(void)
{
	if(parms == NULL)
	{
		Con_Print("format: coop <0/1>");
		return;
	}

	if(!strcmp(parms,"1"))
	{
		Con_Print("crosshair on");
		ud.coop = 1;
	}
	else
	if(!strcmp(parms,"0"))
	{
		Con_Print("crosshair off");
		ud.coop = 0;
	}
	else
		Con_Print("coop: unkown parmentor");
}

void cvarcrosshair(void)
{
	if(parms == NULL)
	{
		Con_Print("format: crosshair <0/1>");
		return;
	}

	if(!strcmp(parms,"1"))
	{
		Con_Print("crosshair on");
		ud.crosshair = 1;
	}
	else
	if(!strcmp(parms,"0"))
	{
		Con_Print("crosshair off");
		ud.crosshair = 0;
	}
	else
		Con_Print("crosshair: unkown parmentor");
}

void cvarnoclip(void)
{
	if(parms == NULL)
	{
		Con_Print("format: noclip <0//1>");
		return;
	}

	if(!strcmp(parms,"1"))
	{
		Con_Print("NoClip on");
		ud.clipping = 1;
	}
	else
	if(!strcmp(parms,"0"))
	{
		Con_Print("NoClip off");
		ud.clipping = 0;
		ud.god = 0;
	}
	else
		Con_Print("noclip: unkown parmentor");

}

void cvarallweapons(void)
{
	short weapon;
#ifdef VOLUMEONE
                        j = 6;
#else
                        j = 0;
#endif

                        for ( weapon = PISTOL_WEAPON;weapon < MAX_WEAPONS-j;weapon++ )
                        {
                            addammo( weapon, &ps[myconnectindex], max_ammo_amount[weapon] );
                            ps[myconnectindex].gotweapon[weapon]  = 1;
                        }

                            _handle_events();	keyIsWaiting = false;
                        ps[myconnectindex].cheat_phase = 0;
                        FTA(119,&ps[myconnectindex]);
	Con_Print("All weapons CVAR set");
}

// kind sad...isn;t it?
void cvarirule(void)
{
	int i;

	srand(time(NULL));
	i = rand() % 6;
	

	switch(i)
	{
		case 0:
			Con_Print("Will Duke Nukem 3d ever run under Windows XP?");
		break;
		case 1:
			Con_Print("I really want the source code to Shadow Warrior!!!");
		break;
		case 2:
			Con_Print("Coding is not my strong point...");
		break;
		case 3:
			Con_Print("Ken's ASM code can goto hell and stay there"); // i mean this 2....
		break;
		case 4:
			Con_Print("When the *BEEP* is DNF going to be released?");
		break;
		case 5:
			Con_Print("What is pPey?");
		break;
		case 6:
			Con_Print("Ive played DNF...I work at 3drealms....");
		break;
	}
}
void cvargod(void)
{
	if(parms == NULL)
	{
		Con_Print("format: map <level name>");
		return;
	}

	if(!strcmp(parms,"1"))
	{
		Con_Print("God mode on");
		ud.god = 1;
		SetCvar("GOD","1");
	}
	else
	if(!strcmp(parms,"0"))
	{
		Con_Print("God mode off");
		ud.god = 0;
		SetCvar("GOD","0");
	}
	else
		Con_Print("God mode: unkown parmentor");
}
void cvarmap(void)
{
	if(parms == NULL)
	{
		Con_Print("format: map <level name>");
		return;
	}
	ud.volume_number = 0;
	ud.level_number = 7;
	ud.warp_on = 1;
	//boardfilename = parms;
	strcpy(boardfilename,parms);
//	ps[myconnectindex].gm |= MODE_RESTART;
//	printf("HACK: Entering level %s",boardfilename[0]);
	enterlevel(MODE_GAME);
}
void cvarlist(void)
{
	int i;
	char temp[450];
	printf("DEBUG FUNCTION CALLED");
	for(i=0;i<cvar.curr_cvar; i++)
	{
		sprintf(temp,"%d:%s '%s'",i, cvar.registeredcvars[i],cvar.registeredcvarvalues[i]);
		Con_Print(temp);
	}
}
